const DNSSTUFF_URL = "http://member.dnsstuff.com/includes/ToolHandler.php?";
const DNSSTUFF_TRAILER = "&src=dnsstufftoolbar&token=dnsstufftoolbar";
const ITEMS = new Array(
	"Abuse", "ToolFormName=abuse&domain=",
	"CIDR", "ToolFormName=cidr&ip=",
	"Decimal to IP", "ToolFormName=decimal&ip=",
	"Deobfuscator", "ToolFormName=obfuscated&ip=",
	"DNS Lookup - A", "ToolFormName=lookup&type=A&name=",
	"DNS Lookup - AAAA", "ToolFormName=lookup&type=AAAA&name=", 
	"DNS Lookup - ALL", "ToolFormName=lookup&type=ALL&name=",
	"DNS Lookup - CNAME", "ToolFormName=lookup&type=CNAME&name=",
	"DNS Lookup - MX", "ToolFormName=lookup&type=MX&name=",
	"DNS Lookup - NS", "ToolFormName=lookup&type=NS&name=",
	"DNS Lookup - PTR", "ToolFormName=lookup&type=PTR&name=",
	"DNS Lookup - SOA", "ToolFormName=lookup&type=SOA&name=",
	"DNS Lookup - TXT", "ToolFormName=lookup&type=TXT&name=",
	"DNS Report", "ToolFormName=dnsreport&domain=",
	"DNS Timing - A", "ToolFormName=dnstime&type=A&name=",
	"DNS Timing - AAAA", "ToolFormName=dnstime&type=AAAA&name=",
	"DNS Timing - CNAME", "ToolFormName=dnstime&type=CNAME&name=",
	"DNS Timing - MX", "ToolFormName=dnstime&type=MX&name=",
	"DNS Timing - PTR", "ToolFormName=dnstime&type=PTR&name=",
	"DNS Timing - SOA", "ToolFormName=dnstime&type=SOA&name=",
	"DNS Timing - TXT", "ToolFormName=dnstime&type=TXT&name=",
	"Email Tester", "ToolFormName=mail&domain=",
	"Free Email", "ToolFormName=freemail&domain=",
	"HTTP Headers", "ToolFormName=http&name=",
	"IP Routing", "ToolFormName=whois&server=whois.radb.net&ip=",
	"ISP DNS Cache - A", "ToolFormName=ispdns&type=A&name=",
	"ISP DNS Cache - AAAA", "ToolFormName=ispdns&type=AAAA&name=",
	"ISP DNS Cache - ALL", "ToolFormName=ispdns&type=ALL&name=",
	"ISP DNS Cache - CNAME", "ToolFormName=ispdns&type=CNAME&name=",
	"ISP DNS Cache - MX", "ToolFormName=ispdns&type=MX&name=",
	"ISP DNS Cache - NS", "ToolFormName=ispdns&type=NS&name=",
	"ISP DNS Cache - PTR", "ToolFormName=ispdns&type=PTR&name=",
	"ISP DNS Cache - SOA", "ToolFormName=ispdns&type=SOA&name=",
	"ISP DNS Cache - TXT", "ToolFormName=ispdns&type=TXT&name=",
	"Ping", "ToolFormName=ping&ip=",
	"RDNS Lookup", "ToolFormName=ptr&ip=",
	"Spam DBASE Lookup", "ToolFormName=ip4r&ip=",
	"SSL Lookup", "ToolFormName=ssl&domain=",
	"Traceroute", "ToolFormName=tracert&ip=",
	"Whois/IPWhois", "ToolFormName=whois&ip=",
	"Zone File Dump", "ToolFormName=zonetransfer&name="
		
);
	
var chooserItems = null;
var currentChooserItem = null;
var searchHistory = new Array();
var preferences = null;

function ChooserItem(id, name, query, useTrailer){
	this.id = id;
	this.name = name;
	this.query = query;
	this.useTrailer = useTrailer;
	return this;
};

ChooserItem.prototype = {
	id: null,
	name: null,
	query: null,
	menuItem: null,
	useTrailer: null
};

function dnsStuffLoad(){

	preferences = Components.
	    classes["@mozilla.org/preferences-service;1"].
		  getService(Components.interfaces.nsIPrefService).getBranch("dnsstufftoolbar.");

	setupChooserItems();
	setupChooserMenu();

	if(preferences.prefHasUserValue("dnsstuffselecteditem"))
		selectChooserItem(preferences.getIntPref("dnsstuffselecteditem"));
	else
		selectChooserItem(0);

	document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",cmd_dnsstuffContextPopup,true);

	if(preferences.prefHasUserValue("toolbar.collapsed") && preferences.getBoolPref("toolbar.collapsed"))
		cmd_dnsstufftoggletoolbar();

}

function dnsStuffUnload(){

	if(document.getElementById("dnsstuffToolbar").collapsed)
		preferences.setBoolPref("toolbar.collapsed", true);
	else
		preferences.setBoolPref("toolbar.collapsed", false);
}

function getChooserItem(id){

	var i = 0;

	for(i = 0; i < chooserItems.length; i++){
		if(chooserItems[i].id == id)
			return chooserItems[i];
	}

	return null;
}

function selectChooserItem(id){

	var menuItems = getChooserMenuPopup().childNodes;
	var i = 0;

	if((id < 0) || (id >= menuItems.length)){
		id = 0;
	} 

	for(i = 0; i < menuItems.length; i++){
		menuItems.item(i).setAttribute("checked", false);
	}

	currentChooserItem = getChooserItem(id);
	
	for(i = 0; i < menuItems.length; i++){
		if(menuItems.item(i) == currentChooserItem.menuItem){
			menuItems.item(i).setAttribute("checked", true);
			break;
		}
	}

	getChooserMenu().setAttribute("label", currentChooserItem.name);
	document.getElementById("dnsstufftextbox").focus();
	preferences.setIntPref("dnsstuffselecteditem", id);				
}

function cmd_dnsstufftoggletoolbar(){

	var toolbar = document.getElementById("dnsstuffToolbar");
	

	if(toolbar.collapsed == true){
		toolbar.setAttribute("collapsed", false);
	}
	else
		toolbar.setAttribute("collapsed", true);

	preferences.setBoolPref("toolbar.collapsed", toolbar.collapsed);
}

function getChooserMenu(){

	return document.getElementById("dnsstuffchoosermenu");
}

function getChooserMenuPopup(){
	
	return document.getElementById("dnsstuff_choosermenupopup");
}

function setupChooserMenu(){

	var chooserMenu = getChooserMenuPopup();
	var temp = null;
	var i = 0;

	for(i = 0; i < chooserItems.length; i++){
		temp = document.createElement("menuitem");
		temp.setAttribute("label", chooserItems[i].name);
		temp.setAttribute("id", "dnsChooserItem-" + chooserItems[i].id);
		temp.setAttribute("checked", false);
		temp.setAttribute("oncommand", "cmd_chooserMenu(this)");
		chooserItems[i].menuItem = temp;
		chooserMenu.appendChild(temp);	
	}	
			
}

function getItemFromMenuItem(menuItem){

	var i = 0;

	for(i = 0; i < chooserItems.length; i++){
		if(chooserItems[i].menuItem == menuItem)
			return chooserItems[i];
	}

	return null;
}

function cmd_dnsstuffSearch(){
	
	var query;
	var textBox;
	var i;

	textbox = document.getElementById("dnsstufftextbox");
	var url = currentChooserItem.query + textbox.value;
	
	if(currentChooserItem.useTrailer){
	    url = url + DNSSTUFF_TRAILER;
	}
	
//	openNewTabWith(url, null, null, true);
        var newTab = window.gBrowser.addTab(url);
        window.gBrowser.selectedTab = newTab; 

	query = new String(textbox.value);
	query = trim(query);
	query = query.toLowerCase();
	
	while(searchHistory.length > 10){
		searchHistory.pop();
	}

	for(i = 0; i < searchHistory.length; i++){
		if(searchHistory[i] == query){
			searchHistory.splice(i, 1);
			i = 0;
			continue;
		}
	}

	searchHistory.unshift(query);
	textbox.removeAllItems();
	
	for(i = 0; i < searchHistory.length; i++){
		textbox.insertItemAt(i, searchHistory[i], searchHistory[i]);
	}

}

function cmd_chooserMenu(item){

	selectChooserItem(getItemFromMenuItem(item).id);	
}

function cmd_dnsstuffGrabUrl(){

	var url = new String(window._content.document.location);
	var index = url.indexOf("://");
	var box = document.getElementById("dnsstufftextbox");

	if(index != -1){
		url = url.substring(index + 3);
	}

	index = url.indexOf("/");

	if(index != -1){
		url = url.substring(0, index);
	}

	box.value = url;
}

function setupChooserItems(){

	var temp = null;
	var i = 0;
	var x = 0;
	
	chooserItems = new Array();

	for(i = 0; i < (ITEMS.length/2); i++){
		
		if(ITEMS[x+1].indexOf("http://") != 0)
			temp = new ChooserItem(i, ITEMS[x], DNSSTUFF_URL + ITEMS[x+1], true);
		else
			temp = new ChooserItem(i, ITEMS[x], ITEMS[x+1], false);

		chooserItems.push(temp);
		x = x + 2;
	}
 
}

function cmd_showChooserMenu(){

	getChooserMenuPopup().showPopup(getChooserMenu(), -1, -1, "popup", "bottomleft", "topleft");
}

function cmd_dnsstuffContextPopup(){

	var selection = getSelectedText();

	if(selection.length > 0){
		document.getElementById("dnsstuffContextCopy").setAttribute("hidden", false);
	}
	else{
		document.getElementById("dnsstuffContextCopy").setAttribute("hidden", true);
	}
}

function getSelectedText(){

	var node = document.popupNode;
	var selection = "";
	var i = 0;
	var nodeLocalName;

	nodeLocalName = node.localName.toUpperCase();
	if ((nodeLocalName == "TEXTAREA") || (nodeLocalName == "INPUT" && node.type == "text")) {
		selection = node.value.substring(node.selectionStart, node.selectionEnd);
	} 
	else {
        		var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');
        		selection = focusedWindow.getSelection().toString();
    	}
	selection = new String(selection);
	selection = selection.toLowerCase();
	
	for(i = 0; i < selection.length; i++){
	
		if(((selection.charCodeAt(i) >= 0x30) && (selection.charCodeAt(i) <= 0x39))
			|| ((selection.charCodeAt(i) >= 0x61) && (selection.charCodeAt(i) <= 0x7A))){
			break;
		}
		
		selection = selection.substring(1);
		i = 0; 
	}
	
	if(selection.length > 0){
		i = selection.indexOf(" ");

		if(i != -1)
			selection = selection.substring(0, i);
	}

	return selection;
}

function trim(toTrim){

	var temp = new String(toTrim);

	for(i = 0; i < temp.length; i++){
	
		if(temp.charCodeAt(i) > 0x21){
			break;
		}
		
		temp = temp.substring(1);
		i = 0; 
	}	

	for(i = temp.length-1; i >= 0; i--){
	
		if(temp.charCodeAt(i) > 0x21){
			break;
		}
		
		temp = temp.substring(i, i-1);
		i = temp.length-1; 
	}	
	
	return temp;
}

function cmd_dnsstuffCopy(){
    
	var selection = getSelectedText();

	if(selection.length > 0){
		if(document.getElementById("dnsstuffToolbar").collapsed)
			cmd_dnsstufftoggletoolbar();

		document.getElementById("dnsstufftextbox").value = selection;
	}
}

function getPrivateIp(){

	var dnsutil = Components.
	    classes["@mozilla.org/network/dns-service;1"].
		  getService(Components.interfaces.nsIDNSService);

	
	return resolve(dnsutil.myHostName, true);	
}

function resolve(name, forward){

	var dnsutil = Components.
	    classes["@mozilla.org/network/dns-service;1"].
		  getService(Components.interfaces.nsIDNSService);

	
	var list = dnsutil.resolve(name, true);

	if(forward){
		var resolveString = "";	
		var i = 0;

		while(list.hasMore()){
			if(i == 0)
				resolveString = list.getNextAddrAsString();
			else
				resolveString = resolveString + "," + list.getNextAddrAsString();
			i++;
		
		}
	}
	else resolveString = list.canonicalName;		

	if(resolveString == "") resolveString = "Unknown";

	return resolveString;	
}

function getPublicIp(){

	var xml = new XMLHttpRequest();
	var searchString = "Your IP: <strong>";
	xml.open("GET", "http://www.dnsstuff.com", false);
	xml.send(null);

	var xmlData = xml.responseText;
	var ipString = "";
	
	if((xmlData != null) && (xmlData.length > 0)){
		var index = xmlData.indexOf(searchString) + searchString.length;
		
		if(index != -1){
			xmlData = xmlData.substring(index);

			index = 0;
			while(xmlData.charAt(index) != "<") index++;

			ipString = xmlData.substring(0, index);
		}
		else ipstring = "";
	}

	if(ipString == "") ipString = "Unknown";

	return ipString;
}

function resolveIps(ipString){

	var ipArray = ipString.split();
	var resolveString = "";

	for(var i = 0; i < ipArray.length; i++){
		if(i == 0)
			resolveString = resolve(ipArray[i], false);
		else
			resolveString = resolveString + "," + resolve(ipArray[i], false);
	}

	return resolveString;
}

function cmd_showIPInfo(){

	var privateIp = getPrivateIp().split(",");
	var publicIp = getPublicIp();
	var newTab = window.gBrowser.addTab("");
        window.gBrowser.selectedTab = newTab; 

	window._content.document.write("<html><head><title>My IP Information</title></head><body>");
	
	for(var i = 0; i < privateIp.length; i++)
		window._content.document.write("Private IP #" + (i+1) + ": " + privateIp[i] + "<br>");

	window._content.document.write("Public IP: " + publicIp + "<br>");
	window._content.document.write("</body></html>");
	window._content.document.close();
}